# Official language image. Look for the different tagged releases at:
# https://hub.docker.com/r/library/python/tags/
image: python:latest

# Change pip's cache directory to be inside the project directory since we can
# only cache local items.
variables:
  PIP_CACHE_DIR: "$CI_PROJECT_DIR/.cache/pip"

# Pip's cache doesn't store the python packages
# https://pip.pypa.io/en/stable/reference/pip_install/#caching
#
# If you want to also cache the installed packages, you have to install
# them in a virtualenv and cache it as well.
cache:
  paths:
    - .cache/pip
    - venv/

before_script:
  - python -V  # Print out python version for debugging
  - python3 -m venv venv
  - source venv/bin/activate
  - pip install --upgrade pip
  - pip install -r requirements.txt

# All formatting/syntax/linting tests to be run on any branch except master
run:
  stage: test
  script:
    - flake8 --benchmark lib/pensando
  only:
    - branches
  except:
    - main

# Only build new docs when we deploy to master
pages:
  stage: deploy
  script:
    - pip install sphinx sphinx_rtd_theme
    - cd docs ; make html
    - mv _build/html/ ../public/
  artifacts:
    paths:
      - public
  only:
    - main
